

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable CLKSRC 0
    variable CLKDIV2 0

    variable DCM "unknown!!"

    variable OptionMenu
    set OptionMenu [list "Onboard (104MHz)" External "Onboard (52MHz)" Reserved "FPDP Rx Clock" "RapidCHANNEL Rx Clock" "FPGA generated" "FPGA generated"]


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
   }

    proc UpdateClock {} {
        variable DCM

        set boardID [set ::LyrTech::boardID]

        set rc [ReadVHSADCFpgaRegister $boardID 0x08]  ;# clocks control register

        if {[expr $rc & 0x100] == 0} {
           InsertLog "Warning: Board Index $boardID: DCM clock NOT locked"
        } else {
          InsertLog "Information: Board $boardID: DCM clock IS locked"
        }

        set ::vhsadcC::CLKSRC [expr $rc & 7]  ;# CLK SRC
        set ::vhsadcC::CLKDIV2 [expr ($rc >> 15) & 1]

        if {[expr $rc & 0x100] == 0} {set DCM "NOT locked"} else {set DCM "Locked"}

        if {[expr $rc & 0x80] != 0} {InsertLog "Warning: Reset FPGA DCM bit is set"}
    }

    proc do_ResetDCM {} {
        set boardID [set ::LyrTech::boardID]

        set rc [ReadVHSADCFpgaRegister $boardID 0x08]  ;# clocks control register
        WriteVHSADCFpgaRegister $boardID 0x08 [expr ($rc & 0x0000ff7f) | 0x80]  ;# set Reset DCM bit

        set rc [ReadVHSADCFpgaRegister $boardID 0x08]  ;# clocks control register
        if {[expr ($rc >> 7) & 1] == 1} {
            InsertLog "FPGA DCM reset bit NOT cleared"
            WriteVHSADCFpgaRegister $boardID 0x08 [expr $rc & 0x0000ff7f]  ;# unset Reset DCM bit
        }

        UpdateClock

#   MWD firmware

        set reg 1                                               ;# Status Word
        set chan 0
        set rc [ReadVHSADCUserRegister $chan $reg]
        if {[expr $rc & 8] == 0} {
             InsertLog "Warning: Board Index $boardID: decclk_locked bit NOT set"
        } else {
#            InsertLog "Information: Board Index $boardID: decclk_locked bit IS set"
        }

    }

    proc do_Setting {vl} {
        variable CLKSRC; set CLKSRC $vl

        set boardID [set ::LyrTech::boardID]

        set rc [ReadVHSADCFpgaRegister $boardID 0x08]  ;# clocks control register
        WriteVHSADCFpgaRegister $boardID 0x08 [expr ($rc & 0x00000ff8) + 0x2000 + $vl]  ;# set CLK SRC bits

        do_ResetDCM
    }

    proc UpdateModule {} {UpdateClock}

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}
  
       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [first [lindex $cgidata 1]]
               set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   RESETDCM  {do_ResetDCM}
                   SETTING   {do_Setting $vl}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

