
#    RunControl specific for LyrTech Project

global env

namespace eval DataAcquisition {
     variable PROJECT; if {![info exists PROJECT]} {set PROJECT LyrTech}
     variable ACQSERVERS; if {![info exists ACQSERVERS]} {set ACQSERVERS [list $env(ComputerName)]}
     variable ACQSERVER; if {![info exists ACQSERVER]} {set ACQSERVER [first $ACQSERVERS]}
}

namespace eval $::DataAcquisition::PROJECT {
    variable DBRootName; if {![info exists DBRootName]} {set DBRootName [file join EXPERIMENTS $::DataAcquisition::PROJECT]}
    variable DBNodeBase; if {![info exists DBNodeBase]} {set DBNodeBase 2017}
    variable DBNodeName; if {![info exists DBNodeName]} {set DBNodeName $env(ComputerName)}
}

puts "loading tcl/LyrTechRunControl.tcl for namespace [namespace current]"

  if {[llength $::DataAcquisition::ACQSERVERS] > 1} {

    set z [catch {package require RunControlClient} m]
    if {$z != 0} {puts "RunControlClient returned z=$z and $m"} else {puts "RunControlClient loaded"}

    set f [file join $env(MIDASBASE) TclHttpd Html LyrTech RunControl stats.defn.tcl]
    if {[file exists $f]} {
#    note that reading this defines the elements of the ITEM array
        set z [catch {source $f} m]
    }

  } else {

#   for the case  llength $::DataAcquisition::ACQSERVERS == 1

    set z [catch {package require RunControlServer} m]
    if {$z != 0} {puts "RunControlServer returned z=$z and $m"} else {puts "RunControlServer loaded"}


#    provides the following 

#   Appdo_Setup
#   Appdo_Stop
#   Appdo_Go
#   Appdo_Reset
#   Appdo_SetOption
#   Appdo_GetOption
#   Appdo_GetCounters
#   Appdo_GetRates
#   Appdo_GetState


   global env

     set f [file join $env(MIDASBASE) TclHttpd Html RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "RunControl returned z=$z and $m"} else {puts "RunControl loaded"}

     set f [file join $env(MIDASBASE) TclHttpd Html LyrTech RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "LyrTech RunControl returned z=$z and $m"} else {puts "LyrTech RunControl loaded"}

  }

global MIDAS_LyrTechRunControl_Exists
set MIDAS_LyrTechRunControl_Exists 1

global MIDAS_LYRTECHRunControl_Exists
set MIDAS_LYRTECHRunControl_Exists 1

package provide LyrTechRunControl 1.0
